module Exam.Exercise1.SoundnessBigStep where

open import Exam.Exercise1.Syntax
open import Exam.Exercise1.Typing
open import Exam.Exercise1.Substitution
open import Exam.Exercise1.SemanticsBigStep
open import Exam.Exercise1.SoundnessSubstitution using (subst-preserve)

-- The following theorem states type soundness for the big-step semantics.
-- If a term `M` has type `T`, and `M` evaluates to value `V`, then
-- `V` must also have type `T`.
--
-- Since for the big-step semantics, we defined values not as a property
-- of terms, but as a separate type, we make use of the `⌞_⌟` function
-- which converts values to their corresponding term.
--
-- The proof doesn't require any lemmas, except the `subst-preserve` lemma,
-- which is already available due to the `import` on line 7.

soundness : ∀ {M : Term} {T : Type} {V : Value} →
  ∅ ⊢ M ⦂ T →
  M ⇓ V →
  ∅ ⊢ ⌞ V ⌟ ⦂ T
soundness ⊢M M⇓V = {!!}
