module Exam.Exercise1.SoundnessSmallStep where

open import Exam.Exercise1.Syntax
open import Exam.Exercise1.Substitution
open import Exam.Exercise1.SemanticsSmallStep
open import Exam.Exercise1.Typing
open import Exam.Exercise1.SoundnessSubstitution

-- Progress --------------------------------------------------------------------

-- A typed term is either a value or it can make a step.

data Progress (M : Term) : Set where
  step : ∀ {N} → M —→ N → Progress M
  done : Value M → Progress M

-- Example of a term that can neither reduce nor is a value:  zero · zero

progress : ∀ {M} {T} →
  ∅ ⊢ M ⦂ T →
  Progress M
progress (⇒-I ⊢M) = done V-ƛ
progress (⇒-E ⊢M ⊢M₁)
  with progress ⊢M
... | step M->N = step (ξ-·₁ M->N)
progress (⇒-E (⇒-I ⊢M) ⊢M₁) | done V-ƛ
  with progress ⊢M₁
... | step N->N' = step (ξ-·₂ V-ƛ N->N')
... | done value-N = step (β-ƛ value-N)
progress ℕ-I-zero = done V-zero
progress (ℕ-I-suc ⊢M)
  with progress ⊢M
... | step M->N = step (ξ-suc M->N)
... | done value-M = done (V-suc value-M)
progress (ℕ-E-case ⊢M ⊢M₁ ⊢M₂)
  with progress ⊢M
... | step M->N = step (ξ-case M->N)
... | done V-zero = step β-zero
... | done (V-suc value-M) = step (β-suc value-M)
progress (μ-E ⊢M) = step β-μ

-- Preservation ----------------------------------------------------------------

preserve : ∀ {M N} {T} →
  ∅ ⊢ M ⦂ T →
  M —→ N →
  ∅ ⊢ N ⦂ T

preserve (⇒-E (⇒-I ⊢M) ⊢N) (β-ƛ value-N) = subst-preserve ⊢N ⊢M
preserve (ℕ-E-case ⊢M ⊢M₁ ⊢M₂) β-zero = ⊢M₁
preserve (ℕ-E-case (ℕ-I-suc ⊢L) ⊢M ⊢N) (β-suc value-L) = subst-preserve ⊢L ⊢N
preserve (μ-E ⊢M) β-μ = subst-preserve (μ-E ⊢M) ⊢M
preserve (⇒-E ⊢M ⊢M₁) (ξ-·₁ M->M')
  with preserve ⊢M M->M'
... | ⊢M' = ⇒-E ⊢M' ⊢M₁
preserve (⇒-E ⊢M ⊢N) (ξ-·₂ x N->N')
  with preserve ⊢N N->N'
... | ⊢N' = ⇒-E ⊢M ⊢N'
preserve (ℕ-I-suc ⊢M) (ξ-suc M->M')
  with preserve ⊢M M->M'
... | ⊢M' = ℕ-I-suc ⊢M'
preserve (ℕ-E-case ⊢L ⊢M ⊢N) (ξ-case L->L')
  with preserve ⊢L L->L'
... | ⊢L' = ℕ-E-case ⊢L' ⊢M ⊢N
